Require Import Epsilon0 KS.




Example alpha_0 : T1 :=
  ocons (ocons (ocons zero 0 zero)
               0
               zero)
        0
       (ocons (ocons zero 2 zero)
              4
              (ocons zero 1 zero)).

Example alpha_0_eq : alpha_0 = phi0 omega  +
                               phi0 3  * 5 +
                                2.
Proof. reflexivity. Qed.

(** An example of a term which is not in Cantor Normal Form *)
Example bad_term  : T1 := ocons (FS 0) 1 (ocons omega 2 zero).

Remark bad_term_not_nf : not (nf bad_term).
Proof.
intro H; inversion H.
Qed.

Example omega_In_epsilon0  : Ensembles.In _ epsilon_0 omega.
Proof.  repeat    constructor. Qed.

Example e1 :  FS 4 +  FS 6 =  FS 11.
Proof. reflexivity. Qed.

Example e2 : FS 6 + omega = omega.
Proof. reflexivity. Qed.

Example e3 : omega + ocons omega 1 zero = ocons omega 1 zero.
Proof. reflexivity. Qed.

Example  omega_minus_one : omega -  FS 0 = omega.
Proof.  reflexivity. Qed.

Example plus_not_comm : {a:T1 & {b :T1 |
                          nf a /\ nf b /\ a + b  <> b + a}}.
Proof.
 exists (FS 0); exists omega; repeat split.
 - repeat constructor. compute.  discriminate 1. 
Defined.

(** Experimenting canonical sequences

   Note : (d i alpha) is just {alpha}(i)   (KS notation)
*)
 
Example exd :  d 3 (tower 2) = phi0 (FS 2).
Proof.  reflexivity.  Qed.

Example exd' :  d 3 (tower 4) = phi0 (phi0 (phi0 (FS 2))).
Proof.  reflexivity.  Qed.

(* some tests ... *)

Goal omega * phi0 omega = phi0 omega.
Proof.  reflexivity. Qed.

Goal phi0 omega * FS 9 + phi0(FS 1) * FS 2 + omega * FS  7 =
      omega * ((phi0 omega * FS 9 + omega * FS 2 + FS  6) + FS 0).
Proof. trivial. Qed.


Goal d 3 (phi0 (phi0 omega)) = phi0 (phi0 (FS 2)).
Proof.   trivial. Qed.


Goal d 4 (phi0 (omega * FS 1) + phi0 (omega + FS 1) * FS 1) =
phi0 (omega * FS 1) + phi0 (omega + FS 1) + phi0 (omega + One) * FS 3.
Proof.  reflexivity. Qed.

