(** Pierre Castéran, LaBRI and University of Bordeaux

 *)

Require Import List.

Inductive Hydra_alt: Set :=
  hnode (daugthers : list Hydra_alt).

About Hydra_alt_ind. 

Scheme Hydra_alt_ind2 := Induction for Hydra_alt Sort Prop.
About Hydra_alt_ind2.

Section bad_induct. 
Variable P : Hydra_alt -> Prop. 
Goal forall h, P h.
  induction h.
  (*
  1 subgoal, subgoal 1 (ID 7)
  
  P : Hydra_alt -> Prop
  daugthers : list Hydra_alt
  ============================
   P (hnode daugthers)

  *)
  
Abort.

(** abbreviations *)

Notation head := (hnode nil).

Notation hyd1 h := (hnode (h :: nil)).

Notation hyd2 h1 h2 := (hnode (h1 :: h2 :: nil)).
Notation hyd3 h1 h2 h3 := (hnode (h1 :: h2 :: h3 :: nil)).
Fixpoint sum (l: list nat) :=
  match l with
      nil => 0
    | cons i l' => i + sum l'
  end.

About List.map. 

Fixpoint hsize (h : Hydra_alt) : nat :=
  match h with
      hnode l => S (sum (List.map hsize l))
  end. 
Require Import Max. 
Fixpoint max_list (l: list nat) :=
  match l with
      nil => 0
    | a::l' => Max.max a (max_list l')
                       end. 

Fixpoint hheight  (h:Hydra_alt) : nat :=
  match h with hnode l => S (max_list (List.map hheight l))
                           
  end. 

Lemma h_le_s : forall h, hheight h <= hsize h. 
induction h.
 induction daugthers.
 cbn. 
 auto with arith. 
cbn. 
 cbn in IHdaugthers.
Abort.


End bad_induct.