Require Import MoreIota.


Section Examples. 
  Let P (n:nat) := forall p, n <= p.

  Lemma P_unique : exists! i, P i.
  Proof.
  exists 0; split.
  - red;auto with arith.
  - unfold P;intros x Hx;  specialize (Hx 0); now inversion_clear Hx.
Qed.

  Fact inh_nat : inhabited nat.
  Proof.  split; exact 42. Qed.

Let zero := iota inh_nat P.

Goal zero = 0.
  pattern zero; unfold zero;  iota_elim.
  - apply P_unique.
  - destruct 1; auto with arith.
Qed.

Let x := epsilon inh_nat (fun i => i * i < 10).

Example Lx : x < 4.
Proof.
  pattern x; epsilon_elim.
  - (*  exists i : nat, i * i < 10 *)
    exists 0; auto with arith.
  - intros a Ha. 
     destruct (Compare_dec.le_lt_dec 4 a); auto.
      assert (4 * 4 <= a * a). 
      {
         apply Mult.mult_le_compat; auto.
       }
      elimtype False.
      Require Import Omega.
      omega.
 Qed.



End Examples. 