(** works after executing M-x coqparam *)
(** the plug-in is installed in $HOME/testplugin *)
(*

Add LoadPath ".".
Add LoadPath "../coq".
Require Import Parametricity.


Inductive Computation {A:Type}  : Type :=
| Return (a : A)
| Mult (x y : A) (k : A -> Computation).


Parametricity Computation.

(*
Inductive
Computation_R (A₁ A₂ : Type) (A_R : A₁ -> A₂ -> Type)
  : Computation -> Computation -> Type :=
    Return_R : forall (a₁ : A₁) (a₂ : A₂),
               A_R a₁ a₂ -> Computation_R A₁ A₂ A_R (Return a₁) (Return a₂)
  | Mult_R : forall (x₁ : A₁) (x₂ : A₂),
             A_R x₁ x₂ ->
             forall (y₁ : A₁) (y₂ : A₂),
             A_R y₁ y₂ ->
             forall (k₁ : A₁ -> Computation) (k₂ : A₂ -> Computation),
             (forall (H : A₁) (H0 : A₂),
              A_R H H0 -> Computation_R A₁ A₂ A_R (k₁ H) (k₂ H0)) ->
             Computation_R A₁ A₂ A_R (Mult x₁ y₁ k₁) (Mult x₂ y₂ k₂)

For Computation_R: Argument scopes are [type_scope type_scope _ _ _]
For Return_R: Argument scopes are [type_scope type_scope _ _ _ _]
For Mult_R: Argument scopes are [type_scope type_scope _ _ _ _ _ _ _ _ _ _]

*)


(** For star chains *)


Inductive Star_computation {A:Type}  : Type :=
| star_return 
| Mult_by (y : A) (k1 :  Star_computation )
| Mult_by_save  (y : A) (k2 : A -> Star_computation)
| Square (k1 :  Star_computation )
| Square_save  (k2 : A -> Star_computation).


Parametricity Star_computation as Star_R.
(*
Print Star_computation_R.

Inductive
Star_computation_R (A₁ A₂ : Type) (A_R : A₁ -> A₂ -> Type)
  : Star_computation -> Star_computation -> Type :=
    star_return_R : Star_computation_R A₁ A₂ A_R star_return star_return
  | Mult_by_R : forall (y₁ : A₁) (y₂ : A₂),
                A_R y₁ y₂ ->
                forall k1₁ k1₂ : Star_computation,
                Star_computation_R A₁ A₂ A_R k1₁ k1₂ ->
                Star_computation_R A₁ A₂ A_R (Mult_by y₁ k1₁)
                  (Mult_by y₂ k1₂)
  | Mult_by_save_R : forall (y₁ : A₁) (y₂ : A₂),
                     A_R y₁ y₂ ->
                     forall (k2₁ : A₁ -> Star_computation)
                       (k2₂ : A₂ -> Star_computation),
                     (forall (H : A₁) (H0 : A₂),
                      A_R H H0 ->
                      Star_computation_R A₁ A₂ A_R (k2₁ H) (k2₂ H0)) ->
                     Star_computation_R A₁ A₂ A_R 
                       (Mult_by_save y₁ k2₁) (Mult_by_save y₂ k2₂)
  | Square_R : forall k1₁ k1₂ : Star_computation,
               Star_computation_R A₁ A₂ A_R k1₁ k1₂ ->
               Star_computation_R A₁ A₂ A_R (Square k1₁) (Square k1₂)
  | Square_save_R : forall (k2₁ : A₁ -> Star_computation)
                      (k2₂ : A₂ -> Star_computation),
                    (forall (H : A₁) (H0 : A₂),
                     A_R H H0 ->
                     Star_computation_R A₁ A₂ A_R (k2₁ H) (k2₂ H0)) ->
                    Star_computation_R A₁ A₂ A_R (Square_save k2₁)
                      (Square_save k2₂)

For Star_computation_R: Argument scopes are [type_scope type_scope _ _ _]
For star_return_R: Argument scopes are [type_scope type_scope _]
For Mult_by_R: Argument scopes are [type_scope type_scope _ _ _ _ _ _ _]
For Mult_by_save_R: Argument scopes are [type_scope type_scope _ _ _ _ _ _ _]
For Square_R: Argument scopes are [type_scope type_scope _ _ _ _]
For Square_save_R: Argument scopes are [type_scope type_scope _ _ _ _]

*)

*)