(** Avec l'ordre superieur les schémas récursifs simples permettent 
d'écrire la fonction d'Ackermann *)

Fixpoint Ack (n : nat) : nat -> nat :=
  match n with
      0 => S
    | S p => fix A_n  (m : nat) : nat :=
               match m with
                   | 0 => Ack p 1
                   | S q => Ack p (A_n q)
               end
  end.

Lemma Ack_0_m : forall m, Ack 0 m = S m.
Proof.
  trivial.
Qed.

Lemma Ack_Sn_0 : forall n, Ack (S n) 0 = Ack n 1.
Proof.
  trivial.
Qed.

Lemma Ack_Sn_Sm : forall n m, Ack (S n) (S m) =
                              Ack n (Ack (S n) m).
Proof.
  trivial.
Qed.

