(** Solution to an exercise *)

(** The relation " (n,p) is an immediate predecessior of (q,r) " in 
    Cantor's enumeration of nat*nat *)

Require Import Arith Coq.Wellfounded.Inverse_Image Coq.Wellfounded.Inclusion Simple_LexProd.

Inductive prec : nat * nat -> nat * nat -> Prop :=
  in_diag : forall n p,  prec (n, S p) (S n, p)
| next_diag : forall n, prec (n,0) (0, S n).


Definition m := fun p : nat*nat =>
                  (fst p + snd p, fst p).

Definition lt2 := lexico lt lt.

Lemma prec_decr : forall p q:nat*nat, prec p q -> lt2 (m p) (m q).
destruct p ,q; destruct 1; unfold m; cbn; red.
simpl. 
rewrite <- plus_n_Sm; right; auto with arith.
rewrite <- plus_n_O;left. auto with arith.
Qed.


Lemma prec_wf : well_founded prec.
Proof.
  intro p; apply Acc_incl with (fun x y => lt2 (m x) (m y)).
  - intros x y H. now apply prec_decr.
  -  apply Acc_inverse_image.  apply wf_lexico; apply lt_wf.
Qed.